package processbuilder;

import java.io.IOException;
import java.util.*;

/**
 * This code is Copyright 2010 Alvin J. Alexander, http://devdaily.com.
 * You are free to adapt and share this work under the terms of the
 * Creative Commons Attribution-ShareAlike 3.0 Unported License;
 * see http://creativecommons.org/licenses/by-sa/3.0/ for more
 * details.
 */
public class SudoCommandExample
{
  
  public static void main(String[] args) throws Exception
  {
    new SudoCommandExample();
  }

  // can run basic ls or ps commands
  // can run command pipelines
  // can run sudo command if you know the password is correct
  public SudoCommandExample() throws IOException, InterruptedException
  {
    List<String> commands = new ArrayList<String>();
    commands.add("sudo");
    commands.add("lsof");
    commands.add("-i");
    commands.add("-P");
    commands.add("-S");

    // execute the command
    SystemCommandExecutor commandExecutor = new SystemCommandExecutor(commands, "my password");
    int result = commandExecutor.executeCommand();

    // get the stdout and stderr from the command that was run
    StringBuilder stdout = commandExecutor.getStandardOutputFromCommand();
    StringBuilder stderr = commandExecutor.getStandardErrorFromCommand();
    
    // print the stdout and stderr
    System.out.println("The numeric result of the command was: " + result);
    System.out.println("STDOUT:");
    System.out.println(stdout);
    System.out.println("STDERR:");
    System.out.println(stderr);
  }
}
